// マイナスなしの整数チェック
function isNumber(n) {
// /^[0-9]+(\.[0-9]+)?$/ 数値とドット
	if (n.match(/^[0-9]+(\.[0-9]+)?$/)){
		return true;
	} else {
		return false;
	}
}

// 数値チェック
function isInt(n){
	if (n.match(/^[0-9]+$/)){
		return true;
	} else {
		return false;
	}
}

//カンマ編集
function addComma(n) {
	var num = n + "";
	while(num != (num = num.replace(/^(-?\d+)(\d{3})/, "$1,$2")));
	return num;
}


//カンマ編集(削除)
function deleteComma(n) {
	ans = "";
	n = n.replace("万円","");
	n = n.replace("<span>","");
	n = n.replace("</span>","");
	len = n.length;
	for(i = 0; i < n.length; i++){
		t = n.substring(i,i+1);
		if(t == ","){
			t = "";
		}
		ans = ans + t;
	}
	return(ans);
}

//頭金の入力チェック
function downPayCheck(d) {
	if (d == ""){
		alert("頭金が入力されていません。");
		return false;
	}
	if (!isInt(d)){
		alert ("頭金は半角数字（小数点は使えません）で入力してください。");
		return false;
	}
	if(d < 0 || d > 100000){
		alert ("頭金は０万円～１０億円の間で入力してください。");
		return false;
	}
	return true;
}

//ボーナス返済額の入力チェック
function bonusCheck(b, bp, d) {
	if (b == ""){
		alert("内ボーナスが入力されていません。");
		return true;
	}
	if (!isInt(b)){
		alert ("内ボーナスは半角数字（小数点は使えません）で入力してください。");
		return false;
	}
	if((b * 2) > (bp - d)){
		alert ("内ボーナスは借入金（物件価格ー頭金）の半分以下を入力して下さい。");
		return false;
	}
	return true;
}


//借入期間の入力チェック
function spanCheck(s) {
	if (s == ""){
		alert("借入期間が入力されていません。");
		return false;
	}
	if (!isInt(s)){
		alert ("借入期間は半角数字（小数点は使えません）で入力してください。");
		return false;
	}
	if(s < 3 || s > 35){
		alert ("借入期間は３～３５年の間で入力して下さい。");
		return false;
	}
	return true;
}


//金利の入力チェック
function rateCheck(r) {
	if (r == ""){
		alert("金利が入力されていません。");
		return false;
	}
	if (!isNumber(r)){
		alert ("金利は半角数字で入力してください。");
		return false;
	}
	if(r < 0.001 || r > 15.000){
		alert ("金利は0.001～15.000%の間で入力して下さい。");
		return false;
	}
	return true;
}

//価格の入力チェック
function priceCheck(d) {
	if (d == ""){
		alert("価格が入力されていません。");
		return false;
	}
	if(d < 0 || d > 100000000){
		alert ("価格は０万円～１兆円の間で入力してください。");
		return false;
	}
	return true;
}

function BuryNullChara(element){
	if(element.value == ""){
		element.value = "0";
	}
}

//シミュレーションメインルーチン
function loanMonthPaySim(){
	if(!document.getElementById("bukken_price") ||
		 !document.getElementById("loanDownPay") ||
		 !document.getElementById("loanBonus") ||
		 !document.getElementById("loanRate") ||
		 !document.getElementById("loanSpan")){
			return;
	}
	var bukkenPrice = null;
	var downPay = null;
	var bonus = null;
	var rate = null;
	var span = null;

	// 空の場合、0で埋める
	BuryNullChara(document.getElementById("bukken_price"));
	BuryNullChara(document.getElementById("loanDownPay"));
	BuryNullChara(document.getElementById("loanBonus"));
	BuryNullChara(document.getElementById("loanRate"));
	BuryNullChara(document.getElementById("loanSpan"));

	// カンマを抜く処理
	bukkenPrice = deleteComma(document.getElementById("bukken_price").value);
	downPay = deleteComma(document.getElementById("loanDownPay").value);
	bonus = deleteComma(document.getElementById("loanBonus").value);
	rate = deleteComma(document.getElementById("loanRate").value);
	span = deleteComma(document.getElementById("loanSpan").value);

	// バリデートチェック
	if (!(	downPayCheck(downPay) &&
		bonusCheck(bonus, bukkenPrice, downPay) &&
		rateCheck(rate) &&
		spanCheck(span) &&
		priceCheck(bukkenPrice))){
		return;
	}

	// 毎月返済額
	var monthPay = Math.ceil(monthPayCalc(bukkenPrice, downPay, bonus, rate, span));
	// カンマを入れて、金額を入れる
	document.getElementById("loan_pay").innerHTML = addComma(monthPay) + "円";

	// ボーナス月返済額
	var bonusPay = Math.ceil(bonusPayCalc(bonus, rate, span));
	if(document.getElementById("bonus_pay") != null){
		document.getElementById("bonus_pay").innerHTML = addComma(monthPay + bonusPay) + "円";
	}

	// 年支払額
	if(document.getElementById("loan_pay_y") != null){
		document.getElementById("loan_pay_y").innerHTML = addComma(monthPay * 12) + "円";
	}

	// 年ボーナス支払額
	if(document.getElementById("bonus_pay_y") != null){
		document.getElementById("bonus_pay_y").innerHTML = addComma((monthPay * 12) + (bonusPay * 2)) + "円";
	}

	// 総支払額
	var total = (monthPay * span * 12) + (bonusPay * span * 2);
	if(document.getElementById("total_pay") != null){
		document.getElementById("total_pay").innerHTML = addComma(total) + "円";
	}

	// 利息総額
	var difference = total - ((bukkenPrice - downPay) * 10000);
	if(document.getElementById("total_rate") != null){
		document.getElementById("total_rate").innerHTML = addComma(difference) + "円";
	}

}


//毎月返済額の計算(借入金額、頭金、ボーナス、金利、期間)
function monthPayCalc(bp, d, b, r, s){
	var kariire = (Math.ceil(bp - d) * 10000) - (parseInt(b) * 10000);
	var kinri = parseFloat(r) / 100;
	var kaisu = parseInt(s) * 12;
	var bunsi = kariire * (kinri / 12) * Math.pow((1 + (kinri / 12)), kaisu);
	var bunbo = Math.pow((1 + (kinri / 12)), kaisu) - 1;
	return bunsi / bunbo;
}
//ボーナス返済額の計算(ボーナス、金利、期間)
function bonusPayCalc(b, r, s){
	var kariire = (parseInt(b) * 10000);
	var kinri = parseFloat(r) / 100;
	var kaisu = parseInt(s) * 2;
	var bunsi = kariire * (kinri / 2) * Math.pow((1 + (kinri / 2)), kaisu);
	var bunbo = Math.pow((1 + (kinri / 2)), kaisu) - 1;
	return bunsi / bunbo;
}








/**
 * 3桁のカンマ区切りの取得と削除
 */
$(function() {
	// オンロード時
	$.each($(".comma3"), function() {
		set_comma3(this);
	});

	// フォーカス時
	$(".comma3").focus(function() {
		// カンマとスペースを除去（入力ミスを考慮）
		set_comma3_deleted(this);
		// 値が 0 の場合 空にする
		if ($(this).val() == '0') {
			$(this).val("");
		}
	});

	// フォーカスアウト時
	$(".comma3").blur(function() {
		set_comma3(this);
	});

	// クリック時にカンマ除去
	$(".btn-comma3").click(function() {
		$.each($(".comma3"), function() {
			set_comma3_deleted(this);
		});
	});
});

/**
 * 3桁のカンマ区切りの値をセット
 *
 * @param target
 */
function set_comma3(target) {
	var value = $(target).val();
	value = get_comma3(value);
	$(target).val(value);
}

/**
 * 3桁のカンマ区切りの値を取得
 *
 * @param value
 * @returns
 */
function get_comma3(value) {
	// カンマとスペースを除去（入力ミスを考慮）
	var value = get_comma3_deleted(value);

	// カンマ区切り
	while (value != (value = value.replace(/^(-?\d+)(\d{3})/, "$1,$2")));

	// 数値以外の場合は 0
	if (isNaN(parseInt(value))) {
		value = "0";
	}

	return value;
}

/**
 * 3桁のカンマ区切りを除外した値をセット
 *
 * @param target
 */
function set_comma3_deleted(target) {
	var value = $(target).val();
	value = get_comma3_deleted(value);
	$(target).val(value);
}

/**
 * 3桁のカンマ区切りを除外した値を取得
 *
 * @param value
 * @returns
 */
function get_comma3_deleted(value) {
	// 正規表現で扱うために文字列に変換
	value = "" + value;
	// スペースとカンマを削除
	return value.replace(/^\s+|\s+$|,/g, "");
}
